
library appltmgr;

uses WinTypes, WinProcs, CPL, SHELLAPI;


Var
  Section: array[0..5] of char;
  pCPLInfo: PNewCPLInfo;
  szEXEName: array[0..127] of Char;
  ctlInstance: Integer;

Const
  Format: Array [0..6] of Char = 'APP%li'#0;

function CPlApplet (hWndCpl: HWnd; msg: Word;
    lParam1, lParam2: Longint): Longint;export;

begin
  CPlApplet := 1;
  Case msg of
    CPL_INIT:
      begin
        CPlApplet := 1;
        ctlInstance := GetWindowWord (hWndCpl, GWW_HINSTANCE);
      end;

    CPL_GETCOUNT:
      CPlApplet := GetPrivateProfileInt ('Init', 'nApps', 0,
        'APPLTMGR.INI');

    CPL_NEWINQUIRE:
      begin
        pCPLInfo := PNewCPLInfo (lParam2);
        pCPLInfo^.dwSize := SizeOf (TNEWCPLINFO);
        wvsPrintf (@Section, @Format, lParam1);
        GetPrivateProfileString (@Section, 'EXE', '',
          @szEXEName, 127, 'APPLTMGR.INI');
        pCPLInfo^.Icon := ExtractIcon (ctlInstance, @szEXEName, 0);
        GetPrivateProfileString (@Section, 'NAME', '', @pCPLInfo^.szName,
          31, 'APPLTMGR.INI');
        GetPrivateProfileString (@Section, 'DESC', '', @pCPLInfo^.szInfo,
          63, 'APPLTMGR.INI');
        GetPrivateProfileString (@Section, 'HELP', '', @pCPLInfo^.szHelpFile,
          127, 'APPLTMGR.INI');
        pCPLInfo^.dwHelpContext := GetPrivateProfileInt (@Section,
          'CONTEXT', 0, 'APPLTMGR.INI');
        pCPLInfo^.lData := 0;
        CPlApplet := 1;
      end;

    CPL_DBLCLK:
      begin
        wvsPrintf (@Section, @Format, lParam1);
        GetPrivateProfileString (@Section, 'EXE', '',
          @szEXEName, 127, 'APPLTMGR.INI');
        WinExec (@szEXEName, SW_NORMAL);
        CPlApplet := 1;
      end;
  end;
                       
end;

Exports
       CPlApplet resident;

Begin
End.
